package com.gic.cloud.data.hook.api.dto;

import com.gic.cloud.data.hook.api.entity.DownloadApplyStatus;
import com.gic.cloud.data.hook.api.entity.DownloadFileFormat;
import com.gic.cloud.data.hook.api.entity.DownloadTaskStatus;
import com.gic.cloud.data.hook.api.entity.Global;

import java.io.Serializable;
import java.util.Date;

/** 下载任务
 * @author Sam
 */
public class DownloadTask implements Serializable {

	/** 任务编号 */
	protected String id = "";

	/** 任务编号
	 * @return
	 */
	public String getId() {
		return id;
	}

	/** 任务编号
	 * @param id
	 */
	public void setId(String id) {
		this.id = id;
	}

	/** 所属用户编号 */
	protected String userId = "";

	/** 所属用户编号
	 * @return
	 */
	public String getUserId() {
		return userId;
	}

	/** 所属用户编号
	 * @param userId
	 */
	public void setUserId(String userId) {
		this.userId = userId;
	}

	/** 任务命名 */
	protected String name = "";

	/** 任务命名
	 * @return
	 */
	public String getName() {
		return name;
	}

	/** 任务命名
	 * @param name
	 */
	public void setName(String name) {
		this.name = name;
	}

	/** 所属模块名称 */
	protected String moduleName = "";

	/** 所属模块名称
	 * @return
	 */
	public String getModuleName() {
		return moduleName;
	}

	/** 所属模块名称
	 * @param moduleName
	 */
	public void setModuleName(String moduleName) {
		this.moduleName = moduleName;
	}

	/** 任务数据量 */
	protected int amount = 0;

	/** 任务数据量
	 * @return
	 */
	public int getAmount() {
		return amount;
	}

	/** 任务数据量
	 * @param amount
	 */
	public void setAmount(int amount) {
		this.amount = amount;
	}

	/** 任务状态（默认排队中）*/
	protected String status = DownloadTaskStatus.WAITING;

	/** 任务状态
	 * @return
	 */
	public String getStatus() {
		return status;
	}

	/** 任务状态
	 * @param status
	 */
	public void setStatus(String status) {
		this.status = status;
	}

	/** 任务开始时间 */
	protected Date startTime = null;

	/** 任务开始时间
	 * @return
	 */
	public Date getStartTime() {
		return startTime;
	}

	/** 任务开始时间
	 * @param startTime
	 */
	public void setStartTime(Date startTime) {
		this.startTime = startTime;
	}

	/** 任务结束时间 */
	protected Date overTime = null;

	/** 任务结束时间
	 * @return
	 */
	public Date getOverTime() {
		return overTime;
	}

	/** 任务结束时间
	 * @param overTime
	 */
	public void setOverTime(Date overTime) {
		this.overTime = overTime;
	}

	/** 下载任务文件格式 */
	protected String format = DownloadFileFormat.CSV;

	/** 下载任务文件格式
	 * @return
	 */
	public String getFormat() {
		return format;
	}

	/** 下载任务文件格式
	 * @param format
	 */
	public void setFormat(String format) {
		this.format = format;
	}

	/** 是否采用压缩方式 */
	protected String useCompress = Global.NO;

	/** 是否采用压缩方式
	 * @return
	 */
	public String getUseCompress() {
		return useCompress;
	}

	/** 是否采用压缩方式
	 * @param useCompress
	 */
	public void setUseCompress(String useCompress) {
		this.useCompress = useCompress;
	}

	/** 请求数据模式，默认脱敏 */
	protected Integer queryDataType = QueryDataType.SAFE;

	/** 请求数据模式，默认脱敏
	 * @return
	 */
	public Integer getQueryDataType() {
		return queryDataType;
	}

	/** 请求数据模式，默认脱敏
	 * @param queryDataType
	 */
	public void setQueryDataType(Integer queryDataType) {
		this.queryDataType = queryDataType;
	}

	/** 数据来源 */
	protected String queryDataSource = QueryDataSource.FLAT_QUERY;

	/** 数据来源
	 * @return
	 */
	public String getQueryDataSource() {
		return queryDataSource;
	}

	/** 数据来源
	 * @param queryDataSource
	 */
	public void setQueryDataSource(String queryDataSource) {
		this.queryDataSource = queryDataSource;
	}

	/** 真实的查询 */
	protected String realSql = "";

	/** 真实的查询
	 * @return
	 */
	public String getRealSql() {
		return realSql;
	}

	/** 真实的查询
	 * @param realSql
	 */
	public void setRealSql(String realSql) {
		this.realSql = realSql;
	}

	/** 生成文件路径 */
	protected String filePath = "";

	/** 生成文件路径
	 * @return
	 */
	public String getFilePath() {
		return filePath;
	}

	/** 生成文件路径
	 * @param filePath
	 */
	public void setFilePath(String filePath) {
		this.filePath = filePath;
	}

	/** 所属企业编号 */
	protected String enterpriseId = "";

	/** 所属企业编号
	 * @return
	 */
	public String getEnterpriseId() {
		return enterpriseId;
	}

	/** 所属企业编号
	 * @param enterpriseId
	 */
	public void setEnterpriseId(String enterpriseId) {
		this.enterpriseId = enterpriseId;
	}


	/** 报告编号 */
	protected String reportId = "";

	/** 报告编号
	 * @return
	 */
	public String getReportId() {
		return reportId;
	}

	/** 报告编号
	 * @param reportId
	 */
	public void setReportId(String reportId) {
		this.reportId = reportId;
	}


	/** 关联查询相关 */

	/** 关联申请编号 */
	protected String applyId = "";

	/** 关联申请编号
	 * @return
	 */
	public String getApplyId() {
		return applyId;
	}

	/** 关联申请编号
	 * @param applyId
	 */
	public void setApplyId(String applyId) {
		this.applyId = applyId;
	}

	/** 申请状态 */
	protected Integer applyStatus = DownloadApplyStatus.WAITING;

	/** 申请状态
	 * @return
	 */
	public Integer getApplyStatus() {
		return applyStatus;
	}

	/** 申请状态
	 * @param applyStatus
	 */
	public void setApplyStatus(Integer applyStatus) {
		this.applyStatus = applyStatus;
	}

	/** 申请通过 */
	protected String applyPermitted = Global.NO;

	/** 申请通过
	 * @return
	 */
	public String getApplyPermitted() {
//		if (this.queryDataType == QueryDataType.SAFE) {
//			return Global.YES;
//		} else {
//			if (this.applyStatus == DownloadApplyStatus.PERMITTED_BY_SELF || this.applyStatus == DownloadApplyStatus.PERMITTED_BY_OTHER) {
//				return Global.YES;
//			} else return Global.NO;
//		} // IF ELSE OVER
		return this.applyPermitted;
	}

	/** 申请通过
	 * @param applyPermitted
	 */
	public void setApplyPermitted(String applyPermitted) {
		this.applyPermitted = applyPermitted;
	}

	protected Integer desensiType;

	public Integer getDesensiType() {
		return desensiType;
	}

	public void setDesensiType(Integer desensiType) {
		this.desensiType = desensiType;
	}

	private String downloadCondition;

	public String getDownloadCondition() {
		return downloadCondition;
	}

	public void setDownloadCondition(String downloadCondition) {
		this.downloadCondition = downloadCondition;
	}

	private Date downloadTime;

	public Date getDownloadTime() {
		return downloadTime;
	}

	public void setDownloadTime(Date downloadTime) {
		this.downloadTime = downloadTime;
	}

	private Integer downloadWay;

	public Integer getDownloadWay() {
		return downloadWay;
	}

	public void setDownloadWay(Integer downloadWay) {
		this.downloadWay = downloadWay;
	}

	private Integer fieldSize;

	public Integer getFieldSize() {
		return fieldSize;
	}

	public void setFieldSize(Integer fieldSize) {
		this.fieldSize = fieldSize;
	}
}
